package ap.util;

/**
 * Very naive implementation of an LRU cache ... to be improved
 */
class LRUCache[K, V] (maxEntries : Int) {

  private val backend = new scala.collection.mutable.HashMap[K, V]
  
  def get(k : K) : Option[V] = synchronized ( backend get k )
  
  def apply(k : K)(otherwise : => V) : V = (this get k) match {
    case None => {
      val res = otherwise
      this += (k -> res)
      res
    }
    case Some(res) => res
  }
  
  def +=(pair : (K, V)) : unit = synchronized {
    if (backend.size >= maxEntries) backend.clear
    backend += pair
  }
  
}
