package ap.util;

object Logic {
  
  def forall(it : Iterator[Boolean]) : Boolean = {
    while (it.hasNext) {
      if (!it.next) return false
    }
    true
  }
  
  def forall(it : Iterable[Boolean]) : Boolean = forall(it.elements)
  
  def forall(start : Int, end : Int, p : (Int) => Boolean) : Boolean =
    forall(for (i <- PlainRange(start, end).elements) yield p(i))
  
  def exists(it : Iterator[Boolean]) : Boolean = {
    while (it.hasNext) {
      if (it.next) return true
    }
    false
  }

  def exists(it : Iterable[Boolean]) : Boolean = exists(it.elements)

  def exists(start : Int, end : Int, p : (Int) => Boolean) : Boolean =
    exists(for (i <- PlainRange(start, end).elements) yield p(i))

  /**
   * Determines whether <code>true</code> occurs exactly once in the given stream
   */
  def existsOne(it : Iterator[Boolean]) : Boolean = {
    var n : Int = 0
    while (it.hasNext) {
      if (it.next) {
        if (n > 0) return false
        n = n + 1
      }
    }
    n == 1
  }

}
